> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.empiriolabs.ai/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.empiriolabs.ai/_mcp/server.

# DeepSeek V4 Flash 0731

> Post-trained 0731 release with major gains across coding, repository work, tool use, and full-stack tasks, plus a 1M context window.

![DeepSeek V4 Flash 0731](https://media.empiriolabs.ai/model-logos/deepseek.png)

[DeepSeek](/providers/deepseek) · Text Generation

`POST /v1/chat/completions`

Post-trained 0731 release with major gains across coding, repository work, tool use, and full-stack tasks, plus a 1M context window.

## At a glance

| Field               | Value                                                                                                                                |
| ------------------- | ------------------------------------------------------------------------------------------------------------------------------------ |
| Model id            | `deepseek-v4-flash-0731`                                                                                                             |
| Model release date  | 2026-07-31                                                                                                                           |
| Input modalities    | Text                                                                                                                                 |
| Output modalities   | Text                                                                                                                                 |
| Context window      | 1M                                                                                                                                   |
| Weight precision    | -                                                                                                                                    |
| Max output tokens   | 393,216                                                                                                                              |
| Region              | Germany                                                                                                                              |
| Features            | reasoning, function_calling, structured_output, agentic_coding                                                                       |
| Native inference    | No                                                                                                                                   |
| New                 | No                                                                                                                                   |
| Structured output   | JSON Mode                                                                                                                            |
| Supported endpoints | `POST /v1/chat/completions`, `POST /v1/responses`, `POST /v1/messages`, `POST /v1beta/models/deepseek-v4-flash-0731:generateContent` |
| Alternate model ids | `deepseek/deepseek-v4-flash-0731`, `deepseek-ai/deepseek-v4-flash-0731`                                                              |

## Pricing

| Charge              | Spec                    | Rate    |
| ------------------- | ----------------------- | ------- |
| Input               | per 1M prompt tokens    | \$0.424 |
| Output              | per 1M generated tokens | \$1.272 |
| Web Search (Linkup) | per call when invoked   | \$0.013 |

## Example request

```bash
curl https://api.empiriolabs.ai/v1/chat/completions \
  -H 'Authorization: Bearer $EMPIRIOLABS_API_KEY' \
  -H 'Content-Type: application/json' \
  -d '{"model": "deepseek-v4-flash-0731", "messages": [{"role":"user","content":"Hello"}]}'
```

## Parameters

| Parameter            | Type    | Required | Default    | Description                                                                                                                                                                                                                                                                         |
| -------------------- | ------- | -------- | ---------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `temperature`        | number  | no       | `0.7`      | Sampling temperature. 0 = deterministic, 2 = maximum randomness. · Range: 0 – 2                                                                                                                                                                                                     |
| `top_p`              | number  | no       | `0.9`      | Nucleus sampling probability mass. Lower = more focused. · Range: 0 – 1                                                                                                                                                                                                             |
| `max_tokens`         | number  | no       | -          | Maximum output tokens. When omitted, the model's own default applies. · Range: 1 – 393216                                                                                                                                                                                           |
| `stop`               | string  | no       | -          | Up to 4 strings where the model will stop generating further tokens.                                                                                                                                                                                                                |
| `enable_thinking`    | boolean | no       | true       | Enable step-by-step reasoning before answering.                                                                                                                                                                                                                                     |
| `reasoning_effort`   | enum    | no       | `"medium"` | Reasoning effort level. none disables thinking. low, medium, high, and max set bounded thinking budgets sized to the selected model. · Allowed: `none`, `low`, `medium`, `high`, `max`                                                                                              |
| `thinking_budget`    | number  | no       | `32768`    | Maximum tokens reserved for reasoning when thinking is enabled. · Range: 1 – 393216                                                                                                                                                                                                 |
| `response_format`    | enum    | no       | -          | Return the output as a valid JSON object (JSON mode). Describe the fields you want in your prompt.                                                                                                                                                                                  |
| `web_search_linkup`  | boolean | no       | false      | Optional web search powered by Linkup. When enabled, recent web sources are retrieved using your latest user message as the query and provided to the model as additional context. Adds \$0.013 per call when invoked on top of the model's normal token cost. Disabled by default. |
| `disable_formatting` | boolean | no       | false      | Return the answer without the Sources list that web search adds.                                                                                                                                                                                                                    |

## Notes

Thinking is enabled by default and can be disabled. Reasoning tokens are billed as output tokens. Optional Linkup web search is billed only when invoked.

## Variants

### `:variant1`

| Field               | Value                                                                                                                                         |
| ------------------- | --------------------------------------------------------------------------------------------------------------------------------------------- |
| Model id            | `deepseek-v4-flash-0731:variant1`                                                                                                             |
| Model release date  | 2026-07-31                                                                                                                                    |
| Region              | United States                                                                                                                                 |
| Context window      | 1M                                                                                                                                            |
| Weight precision    | -                                                                                                                                             |
| Max output tokens   | 393,216                                                                                                                                       |
| Features            | reasoning, function_calling, structured_output, agentic_coding                                                                                |
| Native inference    | No                                                                                                                                            |
| Structured output   | JSON Schema                                                                                                                                   |
| Supported endpoints | `POST /v1/chat/completions`, `POST /v1/responses`, `POST /v1/messages`, `POST /v1beta/models/deepseek-v4-flash-0731:variant1:generateContent` |

**Pricing**

| Charge              | Spec                    | Rate    |
| ------------------- | ----------------------- | ------- |
| Input               | per 1M prompt tokens    | \$0.44  |
| Output              | per 1M generated tokens | \$1.32  |
| Web Search (Linkup) | per call when invoked   | \$0.013 |

**Parameters**

| Parameter            | Type    | Required | Default    | Description                                                                                                                                                                                                                                                                         |
| -------------------- | ------- | -------- | ---------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `temperature`        | number  | no       | `0.7`      | Sampling temperature. 0 = deterministic, 2 = maximum randomness. · Range: 0 – 2                                                                                                                                                                                                     |
| `top_p`              | number  | no       | `0.9`      | Nucleus sampling probability mass. Lower = more focused. · Range: 0 – 1                                                                                                                                                                                                             |
| `max_tokens`         | number  | no       | -          | Maximum output tokens. When omitted, the model's own default applies. · Range: 1 – 393216                                                                                                                                                                                           |
| `stop`               | string  | no       | -          | Up to 4 strings where the model will stop generating further tokens.                                                                                                                                                                                                                |
| `enable_thinking`    | boolean | no       | true       | Enable step-by-step reasoning before answering.                                                                                                                                                                                                                                     |
| `thinking_budget`    | number  | no       | `32768`    | Maximum tokens reserved for reasoning when thinking is enabled. · Range: 1 – 393216                                                                                                                                                                                                 |
| `reasoning_effort`   | enum    | no       | `"medium"` | Reasoning effort level. none disables thinking. low, medium, high, and max set bounded thinking budgets sized to the selected model. · Allowed: `none`, `low`, `medium`, `high`, `max`                                                                                              |
| `response_format`    | enum    | no       | -          | Constrain the output to JSON. Use JSON mode for any valid JSON object, or JSON schema to force output that matches a schema you provide.                                                                                                                                            |
| `web_search_linkup`  | boolean | no       | false      | Optional web search powered by Linkup. When enabled, recent web sources are retrieved using your latest user message as the query and provided to the model as additional context. Adds \$0.013 per call when invoked on top of the model's normal token cost. Disabled by default. |
| `disable_formatting` | boolean | no       | false      | Return the answer without the Sources list that web search adds.                                                                                                                                                                                                                    |

---

*Machine-readable schema:* `GET https://api.empiriolabs.ai/v1/models/deepseek-v4-flash-0731`.